from trac.wiki.macros import WikiMacroBase
from markdown import markdown
from trac.wiki.formatter import Formatter 
from re import sub, compile, search, I
from StringIO import StringIO

__all__ = ['MarkdownMacro']

#links, autolinks, and reference-style links
LINK = compile(
    r'(\]\()([^) ]+)([^)]*\))|(<)([^>]+)(>)|(\n\[[^]]+\]: *)([^ \n]+)(.*\n)'
)

HREF = compile(r'href=[\'"]?([^\'" ]*)')

class MarkdownMacro(WikiMacroBase):
    def expand_macro(self, formatter, name, txt):
        env = formatter.env
        abs = env.abs_href.base
        abs = abs[:len(abs) - len(env.href.base)]
        f = Formatter(formatter.env, formatter.context)
        def convert(m):
            pre, target, suf = filter(None, m.groups())
            if target[0] == '!': #if we're escaping the link
                return pre+target[1:]+suf                       
            out = StringIO()
            f.format(target, out)
            href_match = search(
                    HREF,
                    out.getvalue(),
                    I)
            if href_match == None:
                return pre+target+suf
            else:
                url = href_match.groups()[0]
            #Turn auto-link which Trac has decided to format (ie are wiki links) into markdown-style links
            if pre == '<' and url != target:
               return "["+target+"]("+url+")"
            return pre + str(url) + suf

        return markdown(sub(LINK, convert, txt), ['extra'])
