from trac.wiki.macros import WikiMacroBase
from markdown import markdown
from trac.wiki.formatter import Formatter 
from re import sub, compile, search, I
from StringIO import StringIO

__all__ = ['MarkdownMacro']

#links, autolinks, and reference-style links
LINK = compile(
    r'(\]\()([^) ]+)([^)]*\))|(<)([^>]+)(>)|(\n\[[^]]+\]: *)([^ \n]+)(.*\n)'
)

HREF = compile(r'href=[\'"]?([^\'" ]*)')

class MarkdownMacro(WikiMacroBase):
    def expand_macro(self, formatter, name, txt):
        env = formatter.env
        abs = env.abs_href.base
        abs = abs[:len(abs) - len(env.href.base)]
        f = Formatter(formatter.env, formatter.context)
        def convert(m):
            pre, target, suf = filter(None, m.groups())
            out = StringIO()
            f.format(target, out)
            url = search(
                    HREF,
                    out.getvalue(),
                    I).groups()[0]
            #Trac creates relative links, which markdown won't touch inside
            # <autolinks> because they look like HTML
            if pre == '<' and url != target:
               pre += abs
            return pre + str(url) + suf

        return markdown(sub(LINK, convert, txt))
